'Prop Monitor1
'2008 Raymond Allen
'This streams screen data continously via serial connection to computer
'Only transmitting info on txpin (not receiving anything). 

CON

  
OBJ
  ser: "fullduplexserial"


VAR
  long cog_monitor
  long stack[100]
  byte ScreenType
  


PUB start(vgaptr, type, txpin) : okay

'' Start monitor driver - starts 2 cogs
'' returns false if no cog available
''
''   vgaptr = pointer to VGA parameters
 '   type = type of screen (V=vga, X=xga)

  ScreenType:=type

  stop

  'start the Prop Monitor
  okay:=cog_monitor:=cognew(PropMonitor(vgaptr),@stack)
  if okay
     if not ser.start(txpin,txpin,0,256000) 'not using RX pin, so setting equal to TX pin#  
       stop
       return false

    
PUB startX(screenptr, colorptr, txpin) : okay

'' Start monitor driver - starts 2 cogs
'' returns false if no cog available
''
''   vgaptr = pointer to VGA parameters
 '   type = type of screen (V=vga, X=xga)

  ScreenType:="X"

  stop

  'start the Prop Monitor
  okay:=cog_monitor:=cognew(PropMonitorX(screenptr,colorptr),@stack)
  if okay
     if not ser.start(txpin,txpin,0,256000) 'not using RX pin, so setting equal to TX pin#  
       stop
       return false

PUB stop

'' Stop PropMonitor driver - frees two cogs  

  if cog_monitor
    cogstop(cog_monitor~ - 1)
    ser.stop
    


PRI PropMonitor(vgaptr)|i,cols,rows,size,pscreen,pcolors

  repeat
    'send sync data
    repeat 4
      ser.tx($F3)              '<-  This is the sync pulse
      ser.tx($F3)
      ser.tx($05)
      
    'send screen type
    ser.tx(ScreenType)
    'send mode
    if (long[vgaptr][3])& %1000
      ser.tx(32) '16x32 mode
    else
      ser.tx(16) '16x16 mode
    'send screen size
    cols:= long[vgaptr][6]
    ser.tx(cols)
    rows:=long[vgaptr][7]
    ser.tx(rows)
    'send screen data
    pscreen:=long[vgaptr][4] 
    size:=cols*rows*2
    repeat i from 0 to size-1
      ser.tx(byte[pscreen][i])
    'send colors
    pcolors:=long[vgaptr][5] 
    size:=4*64           '64 longs= 256 bytes
    repeat i from 0 to size-1
      ser.tx(byte[pcolors][i])
    
      
PRI PropMonitorX(screenptr,colorptr)|i,cols,rows,size

  repeat
    'send sync data
    repeat 4
      ser.tx($F3)              '<-  This is the sync pulse
      ser.tx($F3)
      ser.tx($05)
      
    'send screen type
    ser.tx(ScreenType)
    'send mode
    ser.tx(16) '16x16 mode
    'send screen size
    cols:= 64
    ser.tx(cols)
    rows:= 48
    ser.tx(rows)
    'send screen data
    size:=cols*rows*2
    repeat i from 0 to size-1
      ser.tx(byte[screenptr][i])
    'send colors 
    size:=4*64           '64 longs= 256 bytes
    repeat i from 0 to size-1
      ser.tx(byte[colorptr][i])      
    


